#if !defined(AFX_MYEXCEPTION_H__70AB5B86_0239_4F62_B3F5_61A033D526AF__INCLUDED_)
#define AFX_MYEXCEPTION_H__70AB5B86_0239_4F62_B3F5_61A033D526AF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CMyException
{
	private:
		CMyString m_message;
		CMyString m_param;
		CMyString m_methodeName;
		CMyString m_className;

	public:
		CMyException()
		{
		}

		CMyException(char *className,char *methodeName,char *message,char *param=NULL)
		{
			Init(className,methodeName,message,param);
		}

		void Init (char *className,char *methodeName,char *message,char *param=NULL)
		{
			m_message = message;
			m_methodeName = methodeName;
			m_className = className;
			m_param = param;
			MessageBox(); // for debug
		}

		int MessageBox()
		{
			CMyString temp;
			temp<<"Context: "<<m_className<<m_methodeName<<"\nMessage: "<<m_message;
			if (m_param != "") temp<<"\nValue: "<<m_param;
			return ::MessageBox(NULL,temp,"Error Exception",0);
		}
};

#include "MyString.h"

class CMyExceptionMemory : public CMyException
{
	public:
		CMyExceptionMemory(char *className,char *methodeName,long size)
		{
			CMyString temp;
			temp<<"no more memory for "<<size<<" bytes";
			Init(className,methodeName,temp);
		}
};

#endif // !defined(AFX_MYEXCEPTION_H__70AB5B86_0239_4F62_B3F5_61A033D526AF__INCLUDED_)
