// dependance :  advapi32.lib

#if !defined(AFX_REGISTRE_H__E5A87928_D0D8_11D4_A7DF_00D04C390250__INCLUDED_)
#define AFX_REGISTRE_H__E5A87928_D0D8_11D4_A7DF_00D04C390250__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/* ***************************************************************************************
Example:

	CRegistre reg("HKCU\Software\PlayListManager\Options");
	reg.SetValue("Param1","value1");
*************************************************************************************** */

#include "MyString.h"

#define MAX_REGISTRY_SIZE 4096

class CMyRegistre  
{
	public:
		CMyRegistre (BOOL autoCreate=FALSE);					
		BOOL operator= (char *nameKey);				

		BOOL Read(char *nameKey);
		BOOL RecursiveWrite (char *nameKey);
		BOOL Write(char *nameKey,char *subKey);

		void SetAutoCreate(BOOL autoCreate);

		BOOL GetValue (char *param,char *result);		// chargement d'un parametre
		BOOL SetValue (char *param,char *value);		// sauvegarde d'un parametre

		BOOL GetValue (char *param,long *result);		// chargement d'un parametre
		BOOL SetValue (char *param,long value);			// sauvegarde d'un parametre

		BOOL GetValue (char *param,int *result);		// chargement d'un parametre
		BOOL SetValue (char *param,int value);			// sauvegarde d'un parametre

		BOOL GetValue (char *param , CMyString &result);

		void BeginEnumKey ();
		BOOL NextEnumKey(char *result);

		void BeginEnumValue ();
		BOOL NextEnumValue (char *result);

		// CMyString & operator() (char *param,char *type);// chargement /sauvegarde d'un parametre
		
	private:
		BOOL PrefixKey (char *nameKey);

	private: 
		CMyString m_nameKey;
		int m_numEnumValue;
		int m_numEnumKey;
		HKEY m_hKey;
		BOOL m_isValideKey;
		BOOL m_isAutoCreate;
};


#endif // !defined(AFX_REGISTRE_H__E5A87928_D0D8_11D4_A7DF_00D04C390250__INCLUDED_)
